config/urls.py
from django.conf import settings
from django.conf.urls import url, include

from django.contrib import admin
from django.contrib.auth.views import logout
from django.views.generic import TemplateView

# Import feeds
import core.views
from events.feeds import EventFeed, feedview
import events.reports
import events.views
from ligoauth.views import pre_login, post_login, shib_logout, manage_password
import search.views

# Django admin auto-discover
admin.autodiscover()

feeds = {
    'latest' : EventFeed
}


urlpatterns = [
    url(r'^$', events.views.index, name="home"),
    url(r'^navbar_only$', TemplateView.as_view(
        template_name='navbar_only.html'), name="navbar-only"),
    url(r'^SPInfo', TemplateView.as_view(template_name='gracedb/spinfo.html'),
         name="spinfo"),
    url(r'^SPPrivacy', TemplateView.as_view(
        template_name='gracedb/spprivacy.html'), name="spprivacy"),
    url(r'^DiscoveryService', TemplateView.as_view(
        template_name='discovery.html'), name="discovery"),
    url(r'^events/', include('events.urls')),
    url(r'^superevents/', include('superevents.urls')),
    url(r'^alerts/', include('alerts.urls')),
    url(r'^feeds/(?P<url>.*)/$', EventFeed()),
    url(r'^feeds/$', feedview, name="feeds"),

    url(r'^other/$', TemplateView.as_view(template_name='other.html'),
        name='other'),
    url(r'^performance/$', events.views.performance, name="performance"),
    url(r'^reports/$', events.reports.histo, name="reports"),
    url(r'^reports/cbc_report/(?P<format>(json|flex))?$',
        events.reports.cbc_report, name="cbc_report"),
    url(r'^latest/$', search.views.latest, name="latest"),
    #(r'^reports/(?P<path>.+)$', 'django.views.static.serve',
    #        {'document_root': settings.LATENCY_REPORT_DEST_DIR}),
    url(r'^search/$', search.views.search, name="mainsearch"),

    # Authentication
    url(r'^login/$', pre_login, name='login'),
    url(r'^post-login/$', post_login, name='post-login'),
    url(r'^logout/$', shib_logout, name='logout'),

    # Password management
    url('^manage-password/$', manage_password, name='manage-password'),

    # API URLs
    url(r'^api/', include('api.urls')),
    # Legacy API URLs - must be maintained!
    url(r'^apibasic/', include('api.urls', namespace='legacy_apibasic')),
    url(r'^apiweb/', include('api.urls', namespace='legacy_apiweb')),

    # Heartbeat URL
    url(r'^heartbeat/$', core.views.heartbeat, name='heartbeat'),

    # Uncomment the admin/doc line below and add 'django.contrib.admindocs'
    # to INSTALLED_APPS to enable admin documentation:
    # (r'^admin/doc/', include('django.contrib.admindocs.urls')),
    url(r'^admin/', admin.site.urls),

    # Sessions
    url(r'^', include('user_sessions.urls', 'user_sessions')),

]

# We don't require settings.DEBUG for django-silk since running unit tests
# by default setings settings.DEBUG to False, unless you use the
# --debug-mode flag
if ('silk' in settings.INSTALLED_APPS):
    # Add django-silk
    urlpatterns = [
        url(r'^silk/', include('silk.urls', namespace='silk'))
    ] + urlpatterns

# Add django-debug-toolbar
if settings.DEBUG and 'debug_toolbar' in settings.INSTALLED_APPS:
    import debug_toolbar
    urlpatterns = [
        url(r'^__debug__/', include(debug_toolbar.urls)),
    ] + urlpatterns

gracedb/alerts/urls.py
from django.conf.urls import url

from . import views

app_name = 'alerts'


urlpatterns = [
    # Base /options/ URL
    url(r'^$', views.index, name="index"),

    # Contacts
    url(r'^contact/create/', views.CreateContactView.as_view(),
        name='create-contact'),
    url(r'^contact/(?P<pk>\d+)/edit/$', views.EditContactView.as_view(),
        name="edit-contact"),
    url(r'^contact/(?P<pk>\d+)/delete/$', views.DeleteContactView.as_view(),
        name="delete-contact"),
    url(r'^contact/(?P<pk>\d+)/test/$', views.TestContactView.as_view(),
        name="test-contact"),
    url(r'^contact/(?P<pk>\d+)/request-code/$',
        views.RequestVerificationCodeView.as_view(),
        name="request-verification-code"),
    url(r'^contact/(?P<pk>\d+)/verify/$', views.VerifyContactView.as_view(),
        name="verify-contact"),

    # Notifications
    url(r'^notification/create/$', views.CreateNotificationView.as_view(),
        name="create-notification"),
    url(r'^notification/(?P<pk>\d+)/edit/$',
        views.EditNotificationView.as_view(), name="edit-notification"),
    url(r'^notification/(?P<pk>\d+)/delete/$',
        views.DeleteNotificationView.as_view(), name="delete-notification"),
]

gracedb/api/urls.py
from django.conf.urls import url, include

from .v1 import urls as v1_urls
from .v2 import urls as v2_urls

app_name = 'api'


urlpatterns = [
    url(r'^', include((v1_urls, 'default'))),
    url(r'^v1/', include((v1_urls, 'v1'))),
    url(r'^v2/', include((v2_urls, 'v2'))),
]

gracedb/core/urls.py
# URL utilities

from django.contrib.sites.models import Site


def build_absolute_uri(relative_uri, request=None):
    if request is not None:
        return request.build_absolute_uri(relative_uri)
    else:
        # Assume HTTPS
        domain = Site.objects.get_current().domain
        return 'https://' + domain + relative_uri

gracedb/superevents/urls.py
from django.conf.urls import url, include
from .models import Superevent
from . import views

app_name = 'superevents'


# URLs which are nested below a superevent detail
# These are included under a superevent's ID URL prefix (see below)
suburlpatterns = [

    # Superevent detail view
    url(r'^view/$', views.SupereventDetailView.as_view(), name="view"),

    # File list (file detail/download is handled through the API)
    url(r'^files/$', views.SupereventFileList.as_view(), name="file-list"),
]

# Legacy URL patterns - don't really need them, but we use them for the
# convenience of users who may be accustomed to the legacy event URL patterns
legacy_urlpatterns = [
    # Legacy URLs for superevent detail view
    url(r'^(?P<superevent_id>{regex})/$'.format(
        regex=Superevent.ID_REGEX), views.SupereventDetailView.as_view(),
        name="legacyview1"),
    url(r'^view/(?P<superevent_id>{regex})/$'.format(
        regex=Superevent.ID_REGEX), views.SupereventDetailView.as_view(),
        name="legacyview2"),
]

# Full urlpatterns: legacy urls plus suburlpatterns nested under
# superevent_id
urlpatterns = legacy_urlpatterns + [
    url(r'^(?P<superevent_id>{regex})/'.format(regex=Superevent.ID_REGEX),
        include(suburlpatterns)),

    # View of all candidates
    url(r'^public/O3/$', views.SupereventPublic.as_view(),
        name="public-alerts-O3"),
]

gracedb/core/models.py
from collections import OrderedDict
import logging
import re

from django.db import models, connection
from django.utils import six
from django.contrib.auth import get_user_model
from django.db.models import QuerySet
from django.forms.models import model_to_dict
from django.utils.translation import ugettext_lazy as _

from core.vfile import VersionedFile

# Set up user model
UserModel = get_user_model()

# Set up logger
logger = logging.getLogger(__name__)


class CleanSaveModel(models.Model):
    """Abstract model which automatically runs full_clean() before saving"""

    class Meta:
        abstract = True

    def save(self, *args, **kwargs):
        self.full_clean()
        super(CleanSaveModel, self).save(*args, **kwargs)


class AutoIncrementModel(models.Model):
    """
    An abstract class used as a base for classes which need the
    autoincrementing save method described below.

    AUTO_FIELD: name of field which acts as an autoincrement field.
    AUTO_CONSTRAINTS: tuple of field names to use as a constraint; i.e., the
                      AUTO_FIELD increments relative to the number of rows in
                      the table which have the same values for these fields.
    """
    AUTO_FIELD = None
    AUTO_CONSTRAINTS = None

    class Meta:
        abstract = True

    def save(self, *args, **kwargs):

        # Do a normal save if this is not an insert (i.e., the instance has a
        # primary key already), or if the required fields are not set
        pk_set = self._get_pk_val() is not None
        if (pk_set or (self.AUTO_FIELD is None or
                       self.AUTO_CONSTRAINTS is None)):
            super(AutoIncrementModel, self).save(*args, **kwargs)
        else:
            self.auto_increment_insert(*args, **kwargs)

    def auto_increment_insert(self, *args, **kwargs):
        """
        This custom save method does a SELECT and INSERT in a single raw SQL
        query in order to properly handle a quasi-autoincrementing field, which
        is used to identify instances associated with a ForeignKey. With this
        method, concurrency issues are handled by the database backend.
        Ex: EventLog instances associated with an Event should be numbered from
        1 to N, based on the order of their submission.

        This has been tested with the following classes:
            EventLog, EMObservation, EMFootprint, EMBBEventLog, VOEvent

        Thorough testing is needed to use this method for a new model. Note
        that this method may not work properly for non-MySQL backends.

        Requires AUTO_FIELD and AUTO_CONSTRAINTS to be defined.
        """

        # Check database type
        if connection.vendor != 'mysql':
            raise DatabaseError(_('The custom AutoIncrementModel '
                'auto_increment_save method is not compatible with non-MySQL '
                'backends'))

        # Get some useful information
        meta = self.__class__._meta
        pk_set = self._get_pk_val() is not None

        # Get model fields, except for primary key field.
        fields = [f for f in meta.local_concrete_fields if not
            isinstance(f, models.fields.AutoField)]

        # Check type of self.AUTO_CONSTRAINTS
        if not isinstance(self.AUTO_CONSTRAINTS, (tuple, list)):
            raise TypeError(_('AUTO_CONSTRAINTS should be a tuple or list'))

        # Check constraint fields
        f_names = [f.name for f in fields]
        for constraint_field in self.AUTO_CONSTRAINTS:
            if constraint_field not in f_names:
                raise ValueError(_(('Constraint {0} is not a field for '
                    'model {1}').format(constraint_field,
                    self.__class__.__name__)))

        # Check auto field
        if self.AUTO_FIELD not in f_names:
            raise ValueError(_(('AUTO_FIELD {0} is not a field for '
                'model {1}').format(self.auto_field, self.__class__.__name__)))

        # Setup for generating base SQL query for doing an INSERT.
        query = models.sql.InsertQuery(self.__class__)
        query.insert_values(fields, objs=[self])
        compiler = query.get_compiler(using=self.__class__._base_manager.db)
        compiler.return_id = meta.auto_field is not None and not pk_set

        # Useful function
        qn = compiler.quote_name_unless_alias

        # Compile multiple constraints with AND
        constraint_fields = map(meta.get_field, self.AUTO_CONSTRAINTS)
        constraint_list = ["{0}=%s".format(qn(f.column))
            for f in constraint_fields]
        constraint_values = [f.get_db_prep_value(getattr(self, f.column),
            compiler.connection) for f in constraint_fields]
        constraint_str = " AND ".join(constraint_list)

        with compiler.connection.cursor() as cursor:
            # Get base SQL query as string.
            for sql, params in compiler.as_sql():
                # Modify SQL string to do an INSERT with SELECT.
                # NOTE: it's unlikely that the following will generate
                # a functional database query for non-MySQL backends.

                # Replace VALUES (%s, %s, ..., %s) with
                # SELECT %s, %s, ..., %s
                sql = re.sub(r"VALUES \((.*)\)", r"SELECT \1", sql)

                # Add table to SELECT from, as well as constraints
                sql += " FROM {tbl_name} WHERE {constraints}".format(
                    tbl_name=qn(meta.db_table),
                    constraints=constraint_str
                )

                # Get index corresponding to AUTO_FIELD.
                af_idx = [f.attname for f in fields].index(self.AUTO_FIELD)
                # Put this directly in the SQL; cursor.execute quotes it
                # as a literal, which causes the SQL command to fail.
                # We shouldn't have issues with SQL injection because
                # AUTO_FIELD should never be a user-defined parameter.
                del params[af_idx]
                sql = re.sub(r"((%s, ){{{0}}})%s".format(af_idx),
                    r"\1IFNULL(MAX({af}),0)+1", sql, 1).format(
                    af=self.AUTO_FIELD)

                # Add constraint values to params
                params += constraint_values

                # Execute SQL command.
                cursor.execute(sql, params)

            # Get primary key from database and set it in memory.
            if compiler.connection.features.can_return_id_from_insert:
                id = compiler.connection.ops.fetch_returned_insert_id(cursor)
            else:
                id = compiler.connection.ops.last_insert_id(cursor,
                    meta.db_table, meta.pk.column)
            self._set_pk_val(id)

            # Refresh object in memory in order to get AUTO_FIELD value.
            self.refresh_from_db()

            # Prevents check for unique primary key - needed to prevent an
            # IntegrityError when the object was just created and we try to
            # update it while it's still in memory
            self._state.adding = False


    def auto_increment_update(self, update_field_name, constraints=[],
        allow_update_to_nonnull=False):
        """
        UPDATE superevents_superevent SET gw_date_number = (SELECT N FROM (SELECT IFNULL(MAX(gw_date_number),0)+1 as N FROM superevents_superevent WHERE t_0_date='1980-01-06' AND is_gw=1) AS y) WHERE id=41;
        """

        if (not allow_update_to_nonnull and getattr(self, update_field_name)
            is not None):
            raise ValueError(_(('Attempt to update a non-null constrained auto'
                'field for object {0}. Not allowed.').format(self.__str__())))

        # Setup for generating base SQL query for doing an update
        meta = self._meta
        field = meta.get_field(update_field_name)
        values = [(field, None, field.pre_save(self, False))]
        query = models.sql.UpdateQuery(self.__class__)
        query.add_update_fields(values)
        compiler = query.get_compiler(using=self.__class__._base_manager.db)

        # Useful function
        qn = compiler.quote_name_unless_alias

        # SQL for doing autoincrement
        custom_sql= ("(SELECT N FROM (SELECT IFNULL(MAX({field}),0)+1 AS N "
            "FROM {tbl_name}").format(tbl_name=qn(meta.db_table),
            field=update_field_name)

        # Convert list of field names to be used as constraints into database
        # column names and their values (retrieved from the instance itself)
        constraint_fields = [meta.get_field(f) for f in constraints]
        constraint_list = ["{0}=%s".format(qn(f.column)) for f in constraint_fields]
        values = [f.get_db_prep_value(getattr(self, f.column),
            compiler.connection) for f in constraint_fields]

        # Add constraints to custom SQL (if they are provided)
        if constraint_list:
            custom_sql += (" WHERE " + " AND ".join(constraint_list))

        # Add end
        custom_sql += (") AS temp) WHERE id={pk};".format(pk=self.pk))

        # Replace NULL in base sql update query
        base_sql = compiler.as_sql()[0]
        sql = base_sql.replace('NULL', custom_sql)

        # Execute sql
        compiler.connection.cursor().execute(sql, values)

        # Refresh from database
        self.refresh_from_db(fields=[update_field_name])


class LogBase(models.Model):
    """
    Abstract base class for log message-type objects. Concrete derived
    classes will probably want to add a ForeignKey to another model.

    Used in events.EventLog, superevents.Log
    """
    created = models.DateTimeField(auto_now_add=True)
    issuer = models.ForeignKey(UserModel, null=False)
    filename = models.CharField(max_length=100, default="", blank=True)
    file_version = models.IntegerField(null=True, default=None, blank=True)
    comment = models.TextField(null=False)
    N = models.IntegerField(null=False, editable=False)

    class Meta:
        abstract = True

gracedb/superevents/forms.py
import logging
import os

from django import forms

from superevents.models import Signoff

# Set up logger
logger = logging.getLogger(__name__)


class SignoffForm(forms.ModelForm):

    class Meta:
        model = Signoff
        fields = ['status', 'comment', 'signoff_type', 'instrument']

    def __init__(self, *args, **kwargs):
        super(SignoffForm, self).__init__(*args, **kwargs)
        # Hide some fields that we will populate either by default
        # when we instantiate the form or with the request data
        self.fields['signoff_type'].widget = forms.HiddenInput()
        self.fields['instrument'].widget = forms.HiddenInput()

gracedb/api/v2/events/views.py
from ...v1.events.views import *

gracedb/api/v2/main/views.py
from ...v1.main.views import *

gracedb/api/v2/superevents/views.py
from ...v1.superevents.views import *

gracedb/templates/gracedb/cbc_report.html
{% extends "base.html" %}
{% load scientific %}
{% load timeutil %}

{% block bodyattrs %}
onload="document.search_form.query.focus();"
{% endblock %}

{% block title %}CBC Report{% endblock %}
{% block heading %}{% endblock %} #}
{% block pageid %}CBC Report{% endblock %}

{% block content %}

<div class="content-area">

    {% if message %}
    <p><font color="red"> {{ message }} </font> </p>
    {% endif %}

    <form method="POST" name="search_form">
      <table>
        {{ form.as_table }}
        <tr><td/><td><a href="/documentation/queries.html">Query help</a>
      </table>
    </form>

    {{ title }}
</div>

{% if count > 0 %}
<div class="content-area">
    <h3> IFAR Plot  </h3>
    <div>
        <img src="data:image/png;base64,{{ ifar_plot|safe }}"></img>
    </div>
</div>

<div class="content-area">
    <h3> Mass Distributions </h3>
    <div>
        <img src="data:image/png;base64,{{ mchirp_dist|safe }}"></img>
    </div>

    <div>
        <img src="data:image/png;base64,{{ mass_dist|safe }}"></img>
    </div>
</div>

<div class="content-area">
    <h3> Loudest event table </h3>

    <!-- legend table -->
    <br/>
    <br/>
    <table style="border-spacing:0px;">
        {% for d in FAR_color_map %}
        <tr> <td style="background-color:{{ d.color }}">{{ d.desc }}</td> </tr>
        {% endfor %}
    </table>
    <br/>
    <br/>

    <table class="gstlalcbc">
        <!-- need to select background color based on far. Ucky? -->
        <tr>
            <th>Rank</th>
            <th>GraceID</th>
            <th>gpstime</th>
            <th>FAR</th>
            <th>IFOs</th>
            <th>Total Mass</th>
            <th>Chirp Mass</th>
            <th>SNR</th>
        </tr>
        {% for obj in clustered_events %}
            {% for d in FAR_color_map %}
                {%if obj.far <= d.max_far and obj.far > d.min_far %}
                <tr style="background-color:{{d.color}}">
                {% endif %}
            {% endfor %}
            <td>{{ forloop.counter }} </td>
            <td><a href="{% url "view" obj.graceid %}">{{ obj.graceid }}</a></td>
            <td> {{ obj|end_time }} </td>
            <td> {{ obj.far|scientific }} </td>
            <td> {{ obj.instruments }} </td>
            <td> {{ obj.mass|floatformat:4 }} </td>
            <td> {{ obj.mchirp|floatformat:4 }} </td>
            <td> {{ obj.snr|floatformat:4 }} </td>
        </tr>
        {% endfor %}
    </table>
</div>

{% endif %}

{% endblock %}

gracedb/templates/gracedb/index.html
{% extends "base.html" %}
{% block title %}Home{% endblock %}
{% block heading %}{% endblock %}
{% block pageid %}home{% endblock %}
{% block jscript %}
    <style>
        .question {
            font-family: Helvetica, sans-serif;
            /*font-variant: small-caps; */
            font-style: bold;
            font-size: 18px;
            padding-bottom: 5px;
        }

        .answer {
            margin-left: 30px;
            margin-right: 30px;
            font-size: 14px;
            background-color: #e2ebf2;
            padding-top: 1px;
            padding-bottom: 1px;
            padding-left: 20px;
            padding-right: 20px;
        }
    </style>
{% endblock %}

{% block content %}

<!-- stuff for the recent events plot -->

<style>
body {
  font: 10px sans-serif;
}

.axis text {
  font: 16px sans-serif;
  /*font-weight: bold; */
}

.axis line {
  fill: none;
  stroke: #000;
  shape-rendering: crispEdges;
}

.axis path {
  display: none;
}

.legend {
    font-size: 16px;
    font-weight: bold;
    text-anchor: start;
    cursor: pointer;
}

</style>

{% if recent_events != "" %}
<h2>Recent Events</h2>
<div id="recent_events_plot"></div>
<br/>
{% endif %}

<!-- I find myself needing some more space. -->
<!-- <br/>  -->

<h2>
{% if title %}
    {{ title }}
{% else %}
    GraceDB Overview
{% endif %}
</h2>

<div class="text">

{# Can customize main informational display on home page or just use default #}
{% if information %}
    {{ information|safe }}
{% else %}
    <p>
    The gravitational-wave candidate event database (GraceDB) is a service operated by the <a href="https://www.ligo.org/">LIGO Scientific Collaboration</a>. It provides a centralized location for aggregating and retrieving information about candidate gravitational-wave events. GraceDB provides an <a href="{% url "legacy_apiweb:default:root" %}">API</a> for programmatic access, and a <a href="https://ligo-gracedb.readthedocs.io/">client package</a> is available for interacting with the API.
    </p>
    <h3>Useful information</h3>
    <ul>
    <li><b style="color: red;">*NEW*</b> O3 public alert <a href="{% url "superevents:public-alerts-O3" %}">summary page</a>.</li>
    <li>Information about GW alerts and real-time data products is available in the <a href="https://emfollow.docs.ligo.org/userguide/">LIGO/Virgo Public Alert Guide</a>.</li>
    <li>Found a bug? LIGO/Virgo users can report issues on the GraceDB <a href="https://git.ligo.org/lscsoft/gracedb/issues">Gitlab page</a>.</li>
    </ul>
{% endif %}
    <p><b>Server code version: <a href="https://git.ligo.org/lscsoft/gracedb/tree/gracedb-{{server_version}}">{{server_version}}</a></b></p>
</div>

<!--XXX Infrastructure for human signoffs. Hopefully this will not be permanent. -->
{% if signoff_authorized %}
    {% if signoff_superevent_ids|length or new_signoff_graceids|length or older_signoff_graceids|length %}
    <div class="signoff-area">
    <h2>Attention {{signoff_instrument}} Operator</h2>
    <br />
    {% if signoff_superevent_ids|length %}
        <h3>The following superevents require your signoff:</h3>
        {% if signoff_superevent_ids|length %}
        <ul>
        {% for s_id in signoff_superevent_ids %}
            <li><a href="{% url "superevents:view" s_id %}">{{ s_id }}</a></li>
        {% endfor %}
        </ul>
        {% endif %}
    {% endif %}
    {% if new_signoff_graceids|length or older_signoff_graceids|length %}
        <h3>The following events require your sign-off:</h3>
        {% if new_signoff_graceids|length %}
        <p>Events submitted within the last 24 hours:</p>
        <ul>
        {% for graceid in new_signoff_graceids %}
            <li><a href="{% url "view" graceid %}">{{ graceid }}</a></li>
        {% endfor %} 
        </ul>
        {% endif %}
        {% if older_signoff_graceids|length %}
        <p>Events older than 24 hours:</p>
        <ul>
        {% for graceid in older_signoff_graceids %}
            <li><a href="{% url "view" graceid %}">{{ graceid }}</a></li>
        {% endfor %}
        </ul>
        {% endif %}
    {% endif %}
    <p>Please click on the link(s) above and use the form at the top of the page.</p>
    </div>
    {% endif %}
{% endif %}

<!-- lots of script for the recent events plot -->
{% if recent_events %}
<script src="https://cdnjs.cloudflare.com/ajax/libs/d3/3.5.5/d3.min.js"></script>
<script>

var margin = {top: 0, right: 100, bottom: 70, left: 200};
var width = 1000 - margin.left - margin.right;
var delta_y = 26;

// Times look like "2015-10-15T13:08:31+00:00
var parseDate = d3.time.format("%Y-%m-%dT%X+00:00").parse;

var x = d3.time.scale()
    .range([0, width]);

var y = d3.scale.ordinal()
//var color = d3.scale.category10();
var color = d3.scale.ordinal();

var xAxis = d3.svg.axis()
    .scale(x)
    .orient("bottom");

var svg = d3.select("#recent_events_plot").append("svg")
    .attr("width", width + margin.left + margin.right)


var data_string = '{{ recent_events|safe }}';

var data = JSON.parse(data_string);

// Convert the text in the created column to dates, use to set the x domain.
data.forEach(function(d) {
    d.created = parseDate(d.created);
});
x.domain(d3.extent(data, function(d) { return d.created; }));

// I suspect there is a better and less annoying way of doing all this.
// But I don't really know what it is. We specify the ordering of the 
// pipelines and the color for each pipeline that may be present.
var PIPELINE_ORDER = [ 'gstlal', 'MBTAOnline', 'CWB', 'oLIB', 'Fermi', 'Swift', 'SNEWS', 'HardwareInjection'];

// These are the first 8 colors of category 10
var COLOR_HASH = {};
COLOR_HASH['gstlal']            = '#1f77b4';
COLOR_HASH['MBTAOnline']        = '#ff7f0e';
COLOR_HASH['CWB']               = '#2ca02c';
COLOR_HASH['oLIB']               = '#d62728';
COLOR_HASH['Fermi']             = '#9467bd';
COLOR_HASH['Swift']             = '#8c564b';
COLOR_HASH['SNEWS']             = '#e377c2';
COLOR_HASH['HardwareInjection'] = '#7f7f7f';

// Pull out the unique pipeline names present in the data
var data_pipelines = d3.map(data, function(d) { return d.pipeline; }).keys(); 

// Select pipelines from our ordering according to those present in the data.
var pipelines = [];
PIPELINE_ORDER.forEach(function(d) {
    if (data_pipelines.indexOf(d) >= 0) {
        pipelines.push(d);
    }
});

// Create the list of colors
var pipeline_colors = [];
pipelines.forEach(function(d) {
    pipeline_colors.push(COLOR_HASH[d]);
});

// Now set the domain and range of our color map.
color.domain(pipelines);
color.range(pipeline_colors);

// Now that you know how many pipelines there are, you can determine the height.
height = pipelines.length * delta_y;

var container = svg
    .attr("height", height + margin.top + margin.bottom)
  .append("g")
    .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

// Calculate the height coordinates for the different pipelines.
var y_range_values = [];
pipelines.forEach(function(d, i) {
    y_range_values.push(height - i*delta_y);
});
y.domain(pipelines).range(y_range_values);

// Create the yAxis here, since you need a valid scale.
var yAxis = d3.svg.axis()
    .scale(y)
    .orient("left");

var xAxis_yloc = height + delta_y/2;
container.append("g")
    .attr("class", "x axis")
    .attr("transform", "translate(0," + xAxis_yloc + ")")
    .call(xAxis)
  .selectAll("text")
    .attr("y", 6)
    .attr("x", -12)
    .attr("dy", "0.5em")
    .attr("transform", "rotate(315)")
    .style("text-anchor", "end");

var yAxis_xloc = - delta_y/2;
container.append("g")
    .attr("class", "y axis")
    .attr("transform", "translate(" + yAxis_xloc + ",0)")
    .call(yAxis)

container.selectAll(".y.axis text")
    .attr("fill", function(d) { return color(d); })

var line_length = 12;

var get_url = function(d) {
    return {% url 'home' %} + d.graceid;
}

container.append("g").selectAll("line")
   .data(data)
.enter().append("svg:a")
  .attr("xlink:href", function(d) { return get_url(d); })
.append("line")
  .attr("x1", function(d) { return x(d.created); })
  .attr("x2", function(d) { return x(d.created); })
  .attr("y1", function(d) { return y(d.pipeline) - line_length/2; })
  .attr("y2", function(d) { return y(d.pipeline) + line_length/2; })
  .attr("stroke-width", 5)
  .attr("stroke", function(d) { return color(d.pipeline); })

</script>
{% endif %}
{% endblock %}